/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2020  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.dynamic;

import de.steamwar.bausystem.region.FlagOptional;
import de.steamwar.bausystem.region.FlagStorage;
import de.steamwar.bausystem.region.flags.Flag;
import lombok.NonNull;

import java.util.HashMap;
import java.util.Map;
import java.util.function.Consumer;

public abstract class DefaultFlagStorage implements FlagStorage {

    protected Map<Flag<?>, Flag.Value<?>> flagMap = new HashMap<>();
    private Consumer<FlagStorage> operation;

    @Override
    public <T extends Enum<T> & Flag.Value<T>> boolean set(@NonNull Flag<T> flag, @NonNull T value) {
        if (has(flag).isWritable()) {
            boolean result = flagMap.put(flag, value) != value;
            if (operation != null) {
                operation.accept(this);
            }
            return result;
        } else {
            return false;
        }
    }

    @Override
    public @NonNull <T extends Enum<T> & Flag.Value<T>> FlagOptional<T> get(@NonNull Flag<T> flag) {
        return FlagOptional.of(flag, (T) flagMap.get(flag));
    }

    @Override
    public Map<Flag<?>, Flag.Value<?>> getBackedMap() {
        return flagMap;
    }

    public void setSaveOperation(Consumer<FlagStorage> operation) {
        this.operation = operation;
    }

    public void save() {
        operation.accept(this);
    }
}
